Support Level: 2nd Level Topic: ADTF::DDL

Resolution: Solved Issue FAQ Links:  

Description

Support Anfrage:

Wir übertragen mittels Media Description Codec eine recht große Datenstruktur zwischen zwei Plugins. Das Struct sieht wie folgt

aus:  * eine Liste mit bis zu 40 Objekten  * jedes Objekt hat wiederum 64 Elemente  * Flach gesehen geht es insgesamt um 2572

Elemente, sollten alle 40 Objekte wirklich gesetzt werden

Schon bei 6 Objekten kriege ich merkliche Performance-Probleme auf meinem HP zBook.

In der Loop werden also Codec-bezogene Aufrufe der folgenden Art je Element getätigt:

access_element::find_index(m_oCodecFactory, "lstObj[" + cString::FromType(nObj)  + "].bIsStatic", 

nMediaDescIdx);

oCodec.SetElementValue(nMediaDescIdx, i_sObjList[nObj].bIsStatic); 

 Habt ihr einen Tip, wie man hier mehr Performance reinkriegt? Als letzte Lösung überlegen wir, den Codec wegzulassen und die

Struktur selbst zusammenzusetzen.

Lösung:

Die schnellste Variante ist es die Struktur einfach direkt als C-Struktur im Sample zu befüllen. Die DDL beschreit ja dann genau

diese Struktur, das hat also keinen Nachteil. Ein Codec macht nur Sinn wenn Ihr die Struktur nicht kennt und dynamisch befüllen

müsst (z.b. über eine Konfigurationseinstellung, etc.).

Ansonsten kann man das ganze noch beschleunigen, wenn ihr die teure stringbasierte Suche mit find_index in die Initialisierung

verschiebt und die Indizes cached, dann sollte man nahe an die C-Struktur Variante herankommen.

History

#1 - 2020-09-04 09:59 - hidden

Nachtrag: Der oben beschriebene Ouput wird mit ca. 100 Hz (alle 10 ms) erzeugt.

#2 - 2020-09-04 10:55 - hidden

- Status changed from New to In Progress

- Topic set to ADTF::DDL

#3 - 2020-09-07 11:00 - hidden

Hi Patrick,

die schnellste Variante ist es die Struktur einfach direkt als C-Struktur im Sample zu befüllen. Die DDL beschreit ja dann genau diese Struktur, das

hat also keinen Nachteil. Ein Codec macht nur Sinn wenn Ihr die Struktur nicht kennt und dynamisch befüllen müsst (z.b. über eine

Konfigurationseinstellung, etc.).

Ansonsten kann man das ganze noch beschleunigen, wenn ihr die teure stringbasierte Suche mit find_index in die Initialisierung verschiebt und die

Indizes cached, dann sollte man nahe an die C-Struktur Variante herankommen.

2024-04-10 1/2



Grüße,

Martin

#4 - 2020-09-07 11:56 - hidden

Danke für die Tips.

Das Ticket kann geschlossen werden.

#5 - 2020-09-07 12:04 - hidden

- Status changed from In Progress to To Be Closed

- Resolution set to Solved Issue

#6 - 2020-09-07 12:12 - hidden

- Subject changed from Performance-Probleme mit DDL-Codec to Performance-Problems with the DDL-Codec

- Description updated

#7 - 2020-09-07 12:13 - hidden

- Subject changed from Performance-Problems with the DDL-Codec to Performance-Problems with DDL-Codec

#8 - 2020-09-28 14:06 - hidden

- Status changed from To Be Closed to Closed

- Private changed from Yes to No

#9 - 2020-09-28 14:08 - hidden

- Project changed from 11 to Public Support

#10 - 2021-07-26 13:24 - hidden

- Customer changed from Car.SW Org. to CARIAD
